﻿const docObj = app.activeDocument; //アクティブドキュメントを指定
const artObj = docObj.artboards.getActiveArtboardIndex();//アクティブアートボード番号を読み込む
const rect = docObj.artboards[artObj].artboardRect; //アクティブアートボード座標の読み込み
const artName = docObj.artboards[artObj].name.replace(/\s/g, "_");//アクティブアートボード名称を読み込み　半角スペースを＿に置換
const saveFile = new File(Folder.temp + '/' + artName + '.png'); //保存先をtemp(一時保存)に指定

for(var i = 0 ; i < docObj.layers.length; i++){ //レイヤーの数だけ繰り返す
    docObj.layers[i].locked = true; //レイヤー　ロック
    };

const layObj = docObj.layers.add();//新規レイヤー作成
layObj.name = 'スクショ'; //新規レイヤー名称　変更

//png24形式で保存　ここから
const png24 = new ExportOptionsPNG24();//インスタンス化
png24.antiAliasing = true;//アンチエイリアス　ON　【アンチエイリアス】：斜線やカーブの縁などに現れるギザギザ（ジャギー）を除去してなめらかにすることを
png24.artBoardClipping = true;//アートボード全体が範囲
png24.horizontalScale = 100; //水平方向の比率（％）
png24.verticalScale = 100;//垂直方向の比率（％）
png24.matte = false;//背景色　なし
png24.transparency = true;//背景の透明化
png24.saveAsHTML = false;//HTMLファイルの生成
docObj.exportFile(saveFile, ExportType.PNG24, png24);//exportFile(保存先,保存形式,オプション)
//png24形式で保存　ここまで

//画像の配置　ここから
const scree = layObj.placedItems.add();//画像の配置設定
scree.file = saveFile;//配置画像の読み込み
scree.left = rect[0];//配置位置　左
scree.top = rect[1]; //配置位置　上
scree.width = rect[0] + rect[2];//オブジェクトの横サイズ
scree.height = rect[1] - rect[3];//オブジェクトの縦サイズ
scree.embed();//画像の埋め込み
//画像の配置　ここまで